import { Component, OnInit } from '@angular/core';
import { UpgradeModule } from '@angular/upgrade/static';
import { downgradeInjectable } from '@angular/upgrade/static';
import { DesignStudioService } from 'src/app/core/services/design-studio.service';
import { BrowserStorageService } from 'src/app/core/services/storage/browser-storage.service';

declare var angular: any;
angular
  .module('designStudio')
  .factory('ApiService', downgradeInjectable(DesignStudioService))
  .factory('browserStorageService', downgradeInjectable(BrowserStorageService));

@Component({
  selector: 'gp-design-studio',
  templateUrl: './design-studio.component.html',
  styleUrl: './design-studio.component.scss',
})
export class DesignStudioComponent implements OnInit {
  constructor(private upgrade: UpgradeModule) {}

  ngOnInit(): void {
    // Bootstrap AngularJS if not already bootstrapped
    if (!this.upgrade.$injector) {
      this.upgrade.bootstrap(document.body, ['designStudio'], {
        strictDi: true,
      });
      console.log('AngularJS bootstrapped.');
    } else {
      console.log('AngularJS already bootstrapped.');
    }
  }
}
